
Auto Multiple Choice - Feature # 54: Add a database of questions

Status: WontFix Priority: Normal
Author: red sea Category:
Created: 04/20/2012 Assignee:
Updated: 01/28/2021 Due date:
Description: Proposed to add a database of questions, for use in the creation of tests in the coming years.

History
04/21/2012 02:24 pm - Pieter  Van den Hombergh
red sea wrote:
> Proposed to add a database of questions, for use in the creation of tests in the coming years.

A database needs a database design and that would need design decisions and hence constraints. This can be done for a specific case but is had to do 
in general.
In my experience I am fully satisfied using the file system as a "database", a hierarchical one for that matter and have my several courses in different 
sub directories.
Then in the exam instances I simply include the questions I want to use I a particular exam instance.

Example: The exam looks like this:
<pre>
\documentclass[a4paper]{article}
\usepackage[utf8x]{inputenc}    
\usepackage[T1]{fontenc}
\usepackage{times}
\usepackage{listings}
\usepackage[dutch,german]{babel}
\usepackage[completemulti,separateanswersheet,lang=DE,outsidebox]{automultiplechoice}
\def\CourseDir{/home/hom/fthv/hi/linux/trunk/40_exam}
\def\QuestionBaseDir{\CourseDir/questionsmk2}
\def\ExamInstanceDir{\CourseDir/builds/20120413}
\def\Lecturer{Pieter~van~den~Hombergh}
\scoringDefaultM{haut=2}
\scoringDefaultS{mz=2}
\newcommand\inputQ[1]{\input{\QuestionBaseDir/#1}}
\newif\ifNoShuffle\NoShufflefalse
\def\DECount{16}
\def\NLCount{4}
\def\Columns{2}
\input{\CourseDir/builds/coverpage}
\input{\ExamInstanceDir/processExams}

\end{document}

</pre>

You see a macro there that includes a question file.
The questions are read in the part <pre>\input{\ExamInstanceDir/processExams}
</pre> 

which contains as most important statement
<pre>\input{\ExamInstanceDir/questions.tex}</pre>
which contains a line for each question file like this <pre>\element{general}{\inputQ{subject/chapter/o046.tex}}</pre>
In each question file you should have a unique question identifier that is used by amc.
The relevant line in the question is (example) <pre>\begin{question}{lnx-chap06-o046}</pre>.

This works for me and I have used that for year, even before I found this wonderful AMC software.

In short: do not put the questions inside the exam, but input the with <pre>\input</pre> and you can reuse them any way you like.

04/29/2012 12:25 pm - red sea
thanks.

regards

06/09/2012 03:39 pm - Pieter  Van den Hombergh
red sea wrote:
> thanks.
> 
> regards

See the wiki entry, where you also find an example exam structure.

01/28/2021 08:30 pm - Alexis Bienvenüe
- Status changed from New to WontFix
